import 'package:json_annotation/json_annotation.dart';
import 'package:test_kakao_flutter_sdk/src/user/model/account.dart';

part 'user.g.dart';

/// Response from [UserApi.me()].
@JsonSerializable(
    fieldRename: FieldRename.snake, explicitToJson: true, includeIfNull: false)
class User {
  /// app user id
  int id;

  /// custom properties this user has.
  Map<String, String>? properties;
  Account? kakaoAccount;

  String? groupUserToken;

  DateTime? connectedAt;
  DateTime? synchedAt;

  /// whether this user is connected to the service or not.
  bool? hasSignedUp;

  /// <nodoc>
  User(this.id, this.hasSignedUp, this.properties, this.kakaoAccount,
      this.groupUserToken, this.synchedAt, this.connectedAt);

  /// <nodoc>
  factory User.fromJson(Map<String, dynamic> json) => _$UserFromJson(json);

  /// <nodoc>
  Map<String, dynamic> toJson() => _$UserToJson(this);

  @override
  String toString() => toJson().toString();
}
